/******************************************************************
 *
 *  EE-164 example code
 *  This example illustrates combination of 16-bit EPROM booting, 
 *  16-bit EPROM code execution and 16-bit external SRAM usage.
 *
 *  ANALOG DEVICES INC. (bk) 2003
 *
 ******************************************************************/


#include <def2191.h>


/********************************************************************/
.section / code IVreset;
_reset:	
	jump _main;
		
	
	
/********************************************************************/		
.section / code romcode;
_sys_init:

	l0 = 0;		
	l1 = 0;
	l2 = 0;
	l3 = 0;
	l4 = 0;		
	l5 = 0;
	l6 = 0;
	l7 = 0;
	
	dmpg1 = 0;
	iopg = 0;
	
	ax0 = 0xDEAD;
	ay0 = 0xBEEF;
	ar = ax0 -ay0;
	
	rts;


/********************************************************************/		
.section / code ramcode;
_sram_dummy:

	ax1 = 0xDEAD;
	ay1 = 0xBEEF;
	ar = ax1 -ay1;
	
	rts;
	
	
	
	
	
/********************************************************************/		

.section / code program;
_main:

	ax0=0; ay0=0; ax1=0; ay1=0;

	iopg = External_Memory_Interface_Page;
	ar = 0x086D;	// 5 wait-states
	io(BMSCTL) = ar;
	io(MS0CTL) = ar;
	ar = 0x0078;	// E_BWS = 1: 16 bit
	io(EMICTL) = ar;
	
	iopg = External_Access_Bridge_Page;
	ar = 0x0007;	// initially use always /BMS
	io(E_STAT) = ar;
	
	nop; nop; nop; nop;
	nop; nop; nop; nop;
	
	lcall _sys_init;
	
	iopg = External_Access_Bridge_Page;
	ar = 0x0006;	// now use /MS0 for instruction fetches
	io(E_STAT) = ar;
	
	nop; nop; nop; nop;
	nop; nop; nop; nop;
	
	lcall _sram_dummy;		

	// set breakpoint here and test ax0, ay0, ax1, ay1.
	nop;
	
_forever:
	idle;
	jump _forever;

	
	

/********************************************************************/		
	
